// Class Code Set 23
// Comparision of stats for the graphics window
// and a PImage
// Press any key to toggle the data.

PImage p;

int whichStats;  // odd => graphics window and even => PImage
boolean mouseWasPressed;

void setup( )
{
   size( 600, 600 );
   whichStats = 1;
   mouseWasPressed = false;
   p = loadImage( "jim.jpg" );
   textSize( 20 );

}

void draw( )
{
    background( 255 );
    fill( 255, 0, 0 );
    text("Press space bar to toggle stats.", 10, height-20 );
    if( whichStats % 2 == 1) // graphics stats
    {
        fill( 0 );
        text( "Window Width: " + width, 10, 20 );
        text( "Window Height: " + height, 10, 40 );
      }
    else // image stats
    {
      image( p, 0, 0 );
      fill( 0 );
      text( "Image width: " + p.width,   p.width+10, 20 );
      text( "Image height: " + p.height, p.width+10, 40 );
      if (mouseWasPressed == true)
      {
         int index;
         if ( mouseX < p.width && mouseY < p.height)
         {
           index = mouseY*p.width + mouseX;
         }
         else
         {
              index = 0;
         }
        
         fill( 0 );
         text( "p.pixels.length is " + p.pixels.length, 10, height-80 );
         text( "index of p.pixels is " + index, 10, height-60 );
         text( "color value if p.pixels[index] is " + p.pixels[index], 10, height-40 );
         float r = red( p.pixels[index]);
         float g = green( p.pixels[index]);
         float b = blue( p.pixels[index]);
         text("Red value is " + r, p.width+10, 60);
         text("Green value is " + g, p.width+10, 80);
         text("Blue value is " + b, p.width+10, 100);
      }
    }
}

void keyPressed( )
{
  if ( key == ' ' )
  {
     whichStats++; 
     mouseWasPressed = false;
  }
}

void mousePressed( )
{
   mouseWasPressed = true; 
}

    
 
